pcl::SampleConsensusModelCone< PointT, PointNT > Class Template Reference
Module sample_consensus

SampleConsensusModelCone defines a model for 3D cone segmentation. More...

`#include <pcl/sample_consensus/sac_model_cone.h>`

Inheritance diagram for pcl::SampleConsensusModelCone< PointT, PointNT >:

## Public Types

using | PointCloud = typename SampleConsensusModel< PointT >::PointCloud
using | PointCloudPtr = typename SampleConsensusModel< PointT >::PointCloudPtr
using | PointCloudConstPtr = typename SampleConsensusModel< PointT >::PointCloudConstPtr
using | Ptr = shared_ptr< SampleConsensusModelCone< PointT, PointNT > >
using | ConstPtr = shared_ptr< const SampleConsensusModelCone< PointT, PointNT > >
Public Types inherited from pcl::SampleConsensusModel< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointCloudPtr = typename PointCloud::Ptr
using | SearchPtr = typename pcl::search::Search< PointT >::Ptr
using | Ptr = shared_ptr< SampleConsensusModel< PointT > >
using | ConstPtr = shared_ptr< const SampleConsensusModel< PointT > >
Public Types inherited from pcl::SampleConsensusModelFromNormals< PointT, PointNT >
using | PointCloudNConstPtr = typename pcl::PointCloud< PointNT >::ConstPtr
using | PointCloudNPtr = typename pcl::PointCloud< PointNT >::Ptr
using | Ptr = shared_ptr< SampleConsensusModelFromNormals< PointT, PointNT > >
using | ConstPtr = shared_ptr< const SampleConsensusModelFromNormals< PointT, PointNT > >

## Public Member Functions

| SampleConsensusModelCone (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModelCone. More...
| SampleConsensusModelCone (const PointCloudConstPtr &cloud, const std::vector< int > &indices, bool random=false)
| Constructor for base SampleConsensusModelCone. More...
| SampleConsensusModelCone (const SampleConsensusModelCone &source)
| Copy constructor. More...
| ~SampleConsensusModelCone ()
| Empty destructor. More...
SampleConsensusModelCone & | operator= (const SampleConsensusModelCone &source)
| Copy constructor. More...
void | setEpsAngle (double ea)
| Set the angle epsilon (delta) threshold. More...
double | getEpsAngle () const
| Get the angle epsilon (delta) threshold. More...
void | setAxis (const Eigen::Vector3f &ax)
| Set the axis along which we need to search for a cone direction. More...
Eigen::Vector3f | getAxis () const
| Get the axis along which we need to search for a cone direction. More...
void | setMinMaxOpeningAngle (const double &min_angle, const double &max_angle)
| Set the minimum and maximum allowable opening angle for a cone model given from a user. More...
void | getMinMaxOpeningAngle (double &min_angle, double &max_angle) const
| Get the opening angle which we need minimum to validate a cone model. More...
bool | computeModelCoefficients (const std::vector< int > &samples, Eigen::VectorXf &model_coefficients) const override
| Check whether the given index samples can form a valid cone model, compute the model coefficients from these samples and store them in model_coefficients. More...
void | getDistancesToModel (const Eigen::VectorXf &model_coefficients, std::vector< double > &distances) const override
| Compute all distances from the cloud data to a given cone model. More...
void | selectWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold, std::vector< int > &inliers) override
| Select all the points which respect the given model coefficients as inliers. More...
std::size_t | countWithinDistance (const Eigen::VectorXf &model_coefficients, const double threshold) const override
| Count all the points which respect the given model coefficients as inliers. More...
void | optimizeModelCoefficients (const std::vector< int > &inliers, const Eigen::VectorXf &model_coefficients, Eigen::VectorXf &optimized_coefficients) const override
| Recompute the cone coefficients using the given inlier set and return them to the user. More...
void | projectPoints (const std::vector< int > &inliers, const Eigen::VectorXf &model_coefficients, PointCloud &projected_points, bool copy_data_fields=true) const override
| Create a new point cloud with inliers projected onto the cone model. More...
bool | doSamplesVerifyModel (const std::set< int > &indices, const Eigen::VectorXf &model_coefficients, const double threshold) const override
| Verify whether a subset of indices verifies the given cone model coefficients. More...
pcl::SacModel | getModelType () const override
| Return a unique id for this model (SACMODEL_CONE). More...
Public Member Functions inherited from pcl::SampleConsensusModel< PointT >
| SampleConsensusModel (const PointCloudConstPtr &cloud, bool random=false)
| Constructor for base SampleConsensusModel. More...
| SampleConsensusModel (const PointCloudConstPtr &cloud, const std::vector< int > &indices, bool random=false)
| Constructor for base SampleConsensusModel. More...
virtual | ~SampleConsensusModel ()
| Destructor for base SampleConsensusModel. More...
virtual void | getSamples (int &iterations, std::vector< int > &samples)
| Get a set of random data samples and return them as point indices. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
void | setIndices (const std::vector< int > &indices)
| Provide the vector of indices that represents the input data. More...
IndicesPtr | getIndices () const
| Get a pointer to the vector of indices used. More...
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
unsigned int | getSampleSize () const
| Return the size of a sample from which the model is computed. More...
unsigned int | getModelSize () const
| Return the number of coefficients in the model. More...
void | setRadiusLimits (const double &min_radius, const double &max_radius)
| Set the minimum and maximum allowable radius limits for the model (applicable to models that estimate a radius) More...
void | getRadiusLimits (double &min_radius, double &max_radius) const
| Get the minimum and maximum allowable radius limits for the model as set by the user. More...
void | setSamplesMaxDist (const double &radius, SearchPtr search)
| Set the maximum distance allowed when drawing random samples. More...
void | getSamplesMaxDist (double &radius) const
| Get maximum distance allowed when drawing random samples. More...
double | computeVariance (const std::vector< double > &error_sqr_dists) const
| Compute the variance of the errors to the model. More...
double | computeVariance () const
| Compute the variance of the errors to the model from the internally estimated vector of distances. More...
Public Member Functions inherited from pcl::SampleConsensusModelFromNormals< PointT, PointNT >
| SampleConsensusModelFromNormals ()
| Empty constructor for base SampleConsensusModelFromNormals. More...
virtual | ~SampleConsensusModelFromNormals ()
| Destructor. More...
void | setNormalDistanceWeight (const double w)
| Set the normal angular distance weight. More...
double | getNormalDistanceWeight () const
| Get the normal angular distance weight. More...
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset. More...
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset. More...

## Protected Member Functions

double | pointToAxisDistance (const Eigen::Vector4f &pt, const Eigen::VectorXf &model_coefficients) const
| Get the distance from a point to a line (represented by a point and a direction) More...
bool | isModelValid (const Eigen::VectorXf &model_coefficients) const override
| Check whether a model is valid given the user constraints. More...
bool | isSampleGood (const std::vector< int > &samples) const override
| Check if a sample of indices results in a good sample of points indices. More...
Protected Member Functions inherited from pcl::SampleConsensusModel< PointT >
| SampleConsensusModel (bool random=false)
| Empty constructor for base SampleConsensusModel. More...
void | drawIndexSample (std::vector< int > &sample)
| Fills a sample array with random samples from the indices_ vector. More...
void | drawIndexSampleRadius (std::vector< int > &sample)
| Fills a sample array with one random sample from the indices_ vector and other random samples that are closer than samples_radius_. More...
int | rnd ()
| Boost-based random number generator. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::SampleConsensusModel< PointT >
std::string | model_name_
| The model name. More...
PointCloudConstPtr | input_
| A boost shared pointer to the point cloud data array. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
double | radius_min_
| The minimum and maximum radius limits for the model. More...
double | radius_max_
double | samples_radius_
| The maximum distance of subsequent samples from the first (radius search) More...
SearchPtr | samples_radius_search_
| The search object for picking subsequent samples using radius search. More...
std::vector< int > | shuffled_indices_
| Data containing a shuffled version of the indices. More...
boost::mt19937 | rng_alg_
| Boost-based random number generator algorithm. More...
std::shared_ptr< boost::uniform_int<> > | rng_dist_
| Boost-based random number generator distribution. More...
std::shared_ptr< boost::variate_generator< boost::mt19937 &, boost::uniform_int<> > > | rng_gen_
| Boost-based random number generator. More...
std::vector< double > | error_sqr_dists_
| A vector holding the distances to the computed model. More...
unsigned int | sample_size_
| The size of a sample from which the model is computed. More...
unsigned int | model_size_
| The number of coefficients in the model. More...
Protected Attributes inherited from pcl::SampleConsensusModelFromNormals< PointT, PointNT >
double | normal_distance_weight_
| The relative weight (between 0 and 1) to give to the angular distance (0 to pi/2) between point normals and the plane normal. More...
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset. More...
Static Protected Attributes inherited from pcl::SampleConsensusModel< PointT >
static const unsigned int | max_sample_checks_ = 1000
| The maximum number of samples to try until we get a good one. More...

## Detailed Description

### template<typename PointT, typename PointNT>
class pcl::SampleConsensusModelCone< PointT, PointNT >

SampleConsensusModelCone defines a model for 3D cone segmentation.

The model coefficients are defined as:

- apex.x : the X coordinate of cone's apex
- apex.y : the Y coordinate of cone's apex
- apex.z : the Z coordinate of cone's apex
- axis_direction.x : the X coordinate of the cone's axis direction
- axis_direction.y : the Y coordinate of the cone's axis direction
- axis_direction.z : the Z coordinate of the cone's axis direction
- opening_angle : the cone's opening angle

Author
  Stefan Schrandt

Definition at line 64 of file sac_model_cone.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT, typename PointNT>

using pcl::SampleConsensusModelCone< PointT, PointNT >::ConstPtr = shared_ptr<const SampleConsensusModelCone<PointT, PointNT> >

Definition at line 81 of file sac_model_cone.h.

## PointCloud

template<typename PointT, typename PointNT>

using pcl::SampleConsensusModelCone< PointT, PointNT >::PointCloud = typename SampleConsensusModel<PointT>::PointCloud

Definition at line 76 of file sac_model_cone.h.

## PointCloudConstPtr

template<typename PointT, typename PointNT>

using pcl::SampleConsensusModelCone< PointT, PointNT >::PointCloudConstPtr = typename SampleConsensusModel<PointT>::PointCloudConstPtr

Definition at line 78 of file sac_model_cone.h.

## PointCloudPtr

template<typename PointT, typename PointNT>

using pcl::SampleConsensusModelCone< PointT, PointNT >::PointCloudPtr = typename SampleConsensusModel<PointT>::PointCloudPtr

Definition at line 77 of file sac_model_cone.h.

## Ptr

template<typename PointT, typename PointNT>

using pcl::SampleConsensusModelCone< PointT, PointNT >::Ptr = shared_ptr<SampleConsensusModelCone<PointT, PointNT> >

Definition at line 80 of file sac_model_cone.h.

## Constructor & Destructor Documentation

## SampleConsensusModelCone() [1/3]

template<typename PointT, typename PointNT>

pcl::SampleConsensusModelCone< PointT, PointNT >::SampleConsensusModelCone | ( | const PointCloudConstPtr & | cloud,
|  | bool | random = `false`
| ) |  |

inline

Constructor for base SampleConsensusModelCone.

Parameters

  [in] | cloud | the input point cloud dataset
  [in] | random | if true set the random seed to the current time, else set to 12345 (default: false)

Definition at line 87 of file sac_model_cone.h.

## SampleConsensusModelCone() [2/3]

template<typename PointT, typename PointNT>

pcl::SampleConsensusModelCone< PointT, PointNT >::SampleConsensusModelCone | ( | const PointCloudConstPtr & | cloud,
|  | const std::vector< int > & | indices,
|  | bool | random = `false`
| ) |  |

inline

Constructor for base SampleConsensusModelCone.

Parameters

  [in] | cloud | the input point cloud dataset
  [in] | indices | a vector of point indices to be used from cloud
  [in] | random | if true set the random seed to the current time, else set to 12345 (default: false)

Definition at line 105 of file sac_model_cone.h.

## SampleConsensusModelCone() [3/3]

template<typename PointT, typename PointNT>

pcl::SampleConsensusModelCone< PointT, PointNT >::SampleConsensusModelCone | ( | const SampleConsensusModelCone< PointT, PointNT > & | source | ) |

inline

Copy constructor.

Parameters

  [in] | source | the model to copy into this

Definition at line 123 of file sac_model_cone.h.

## ~SampleConsensusModelCone()

template<typename PointT, typename PointNT>

pcl::SampleConsensusModelCone< PointT, PointNT >::~SampleConsensusModelCone | ( |  | ) |

inline

Empty destructor.

Definition at line 133 of file sac_model_cone.h.

## Member Function Documentation

## computeModelCoefficients()

template<typename PointT , typename PointNT >

bool pcl::SampleConsensusModelCone< PointT, PointNT >::computeModelCoefficients | ( | const std::vector< int > & | samples,
|  | Eigen::VectorXf & | model_coefficients
| ) |  | const

override virtual

Check whether the given index samples can form a valid cone model, compute the model coefficients from these samples and store them in model_coefficients.

The cone coefficients are: apex, axis_direction, opening_angle.

Parameters

  [in] | samples | the point indices found as possible good candidates for creating a valid model
  [out] | model_coefficients | the resultant model coefficients

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 55 of file sac_model_cone.hpp.

## countWithinDistance()

template<typename PointT , typename PointNT >

std::size_t pcl::SampleConsensusModelCone< PointT, PointNT >::countWithinDistance | ( | const Eigen::VectorXf & | model_coefficients,
|  | const double | threshold
| ) |  | const

override virtual

Count all the points which respect the given model coefficients as inliers.

Parameters

  [in] | model_coefficients | the coefficients of a model that we need to compute distances to
  [in] | threshold | maximum admissible distance threshold for determining the inliers from the outliers

Returns
  the resultant number of inliers

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 255 of file sac_model_cone.hpp.

## doSamplesVerifyModel()

template<typename PointT , typename PointNT >

bool pcl::SampleConsensusModelCone< PointT, PointNT >::doSamplesVerifyModel | ( | const std::set< int > & | indices,
|  | const Eigen::VectorXf & | model_coefficients,
|  | const double | threshold
| ) |  | const

override virtual

Verify whether a subset of indices verifies the given cone model coefficients.

Parameters

  [in] | indices | the data indices that need to be tested against the cone model
  [in] | model_coefficients | the cone model coefficients
  [in] | threshold | a maximum admissible distance threshold for determining the inliers from the outliers

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 442 of file sac_model_cone.hpp.

## getAxis()

template<typename PointT, typename PointNT>

Eigen::Vector3f pcl::SampleConsensusModelCone< PointT, PointNT >::getAxis | ( |  | ) | const

inline

Get the axis along which we need to search for a cone direction.

Definition at line 168 of file sac_model_cone.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## getDistancesToModel()

template<typename PointT , typename PointNT >

void pcl::SampleConsensusModelCone< PointT, PointNT >::getDistancesToModel | ( | const Eigen::VectorXf & | model_coefficients,
|  | std::vector< double > & | distances
| ) |  | const

override virtual

Compute all distances from the cloud data to a given cone model.

Parameters

  [in] | model_coefficients | the coefficients of a cone model that we need to compute distances to
  [out] | distances | the resultant estimated distances

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 137 of file sac_model_cone.hpp.

## getEpsAngle()

template<typename PointT, typename PointNT>

double pcl::SampleConsensusModelCone< PointT, PointNT >::getEpsAngle | ( |  | ) | const

inline

Get the angle epsilon (delta) threshold.

Definition at line 158 of file sac_model_cone.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## getMinMaxOpeningAngle()

template<typename PointT, typename PointNT>

void pcl::SampleConsensusModelCone< PointT, PointNT >::getMinMaxOpeningAngle | ( | double & | min_angle,
|  | double & | max_angle
| ) |  | const

inline

Get the opening angle which we need minimum to validate a cone model.

Parameters

  [out] | min_angle | the minimum allowable opening angle of a cone model
  [out] | max_angle | the maximum allowable opening angle of a cone model

Definition at line 187 of file sac_model_cone.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## getModelType()

template<typename PointT, typename PointNT>

pcl::SacModel pcl::SampleConsensusModelCone< PointT, PointNT >::getModelType | ( |  | ) | const

inline override virtual

Return a unique id for this model (SACMODEL_CONE).

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 268 of file sac_model_cone.h.

## isModelValid()

template<typename PointT , typename PointNT >

bool pcl::SampleConsensusModelCone< PointT, PointNT >::isModelValid | ( | const Eigen::VectorXf & | model_coefficients | ) | const

override protected virtual

Check whether a model is valid given the user constraints.

Parameters

  [in] | model_coefficients | the set of model coefficients

Reimplemented from pcl::SampleConsensusModel< PointT >.

Definition at line 495 of file sac_model_cone.hpp.

## isSampleGood()

template<typename PointT , typename PointNT >

bool pcl::SampleConsensusModelCone< PointT, PointNT >::isSampleGood | ( | const std::vector< int > & | samples | ) | const

override protected virtual

Check if a sample of indices results in a good sample of points indices.

Pure virtual.

Parameters

  [in] | samples | the resultant index samples

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 48 of file sac_model_cone.hpp.

## operator=()

template<typename PointT, typename PointNT>

SampleConsensusModelCone& pcl::SampleConsensusModelCone< PointT, PointNT >::operator= | ( | const SampleConsensusModelCone< PointT, PointNT > & | source | ) |

inline

Copy constructor.

Parameters

  [in] | source | the model to copy into this

Definition at line 139 of file sac_model_cone.h.

## optimizeModelCoefficients()

template<typename PointT , typename PointNT >

void pcl::SampleConsensusModelCone< PointT, PointNT >::optimizeModelCoefficients | ( | const std::vector< int > & | inliers,
|  | const Eigen::VectorXf & | model_coefficients,
|  | Eigen::VectorXf & | optimized_coefficients
| ) |  | const

override virtual

Recompute the cone coefficients using the given inlier set and return them to the user.

Note
  : these are the coefficients of the cone model after refinement (e.g. after SVD)

Parameters

  [in] | inliers | the data inliers found as supporting the model
  [in] | model_coefficients | the initial guess for the optimization
  [out] | optimized_coefficients | the resultant recomputed coefficients after non-linear optimization

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 309 of file sac_model_cone.hpp.

## pointToAxisDistance()

template<typename PointT , typename PointNT >

double pcl::SampleConsensusModelCone< PointT, PointNT >::pointToAxisDistance | ( | const Eigen::Vector4f & | pt,
|  | const Eigen::VectorXf & | model_coefficients
| ) |  | const

protected

Get the distance from a point to a line (represented by a point and a direction)

Parameters

  [in] | pt | a point
  [in] | model_coefficients | the line coefficients (a point on the line, line direction)

Definition at line 485 of file sac_model_cone.hpp.

## projectPoints()

template<typename PointT , typename PointNT >

void pcl::SampleConsensusModelCone< PointT, PointNT >::projectPoints | ( | const std::vector< int > & | inliers,
|  | const Eigen::VectorXf & | model_coefficients,
|  | PointCloud & | projected_points,
|  | bool | copy_data_fields = `true`
| ) |  | const

override virtual

Create a new point cloud with inliers projected onto the cone model.

Parameters

  [in] | inliers | the data inliers that we want to project on the cone model
  [in] | model_coefficients | the coefficients of a cone model
  [out] | projected_points | the resultant projected points
  [in] | copy_data_fields | set to true if we need to copy the other data fields

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 346 of file sac_model_cone.hpp.

## selectWithinDistance()

template<typename PointT , typename PointNT >

void pcl::SampleConsensusModelCone< PointT, PointNT >::selectWithinDistance | ( | const Eigen::VectorXf & | model_coefficients,
|  | const double | threshold,
|  | std::vector< int > & | inliers
| ) |  |

override virtual

Select all the points which respect the given model coefficients as inliers.

Parameters

  [in] | model_coefficients | the coefficients of a cone model that we need to compute distances to
  [in] | threshold | a maximum admissible distance threshold for determining the inliers from the outliers
  [out] | inliers | the resultant model inliers

Implements pcl::SampleConsensusModel< PointT >.

Definition at line 189 of file sac_model_cone.hpp.

## setAxis()

template<typename PointT, typename PointNT>

void pcl::SampleConsensusModelCone< PointT, PointNT >::setAxis | ( | const Eigen::Vector3f & | ax | ) |

inline

Set the axis along which we need to search for a cone direction.

Parameters

  [in] | ax | the axis along which we need to search for a cone direction

Definition at line 164 of file sac_model_cone.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## setEpsAngle()

template<typename PointT, typename PointNT>

void pcl::SampleConsensusModelCone< PointT, PointNT >::setEpsAngle | ( | double | ea | ) |

inline

Set the angle epsilon (delta) threshold.

Parameters

  [in] | ea | the maximum allowed difference between the cone's axis and the given axis.

Definition at line 154 of file sac_model_cone.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

## setMinMaxOpeningAngle()

template<typename PointT, typename PointNT>

void pcl::SampleConsensusModelCone< PointT, PointNT >::setMinMaxOpeningAngle | ( | const double & | min_angle,
|  | const double & | max_angle
| ) |  |

inline

Set the minimum and maximum allowable opening angle for a cone model given from a user.

Parameters

  [in] | min_angle | the minimum allowable opening angle of a cone model
  [in] | max_angle | the maximum allowable opening angle of a cone model

Definition at line 176 of file sac_model_cone.h.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel().

The documentation for this class was generated from the following files:

- pcl/sample_consensus/sac_model_cone.h
- pcl/sample_consensus/impl/sac_model_cone.hpp